{% extends 'base.html.twig' %}

{% trans_default_domain 'Map' %}

{% block stylesheets %}
    <link type="text/css" rel="stylesheet" href="{{ asset('css/map.css') }}" />
{% endblock %}

{% block title %}{{ 'tabHeader' | trans }}{% endblock %}

{# Are we currently playing on this world or do we just inspect it? #}
{% set isPlayingInWorld = lord is not null and lord.worldmap.id == world.id %}

{% block javascripts %}
    <script type="text/javascript" src="{{ asset('js/map.js') }}"></script>
    <script type="text/javascript" src="{{ asset('js/webglUtils.js') }}"></script>
    <script type="text/javascript" src="{{ asset('js/shaders.js') }}"></script>
    <script type="text/javascript" src="{{ asset('js/mapZones.js') }}"></script>
    <script type="text/javascript" src="{{ asset('js/mapInitGraphicResources.js') }}"></script>
    <script type="text/javascript" src="{{ asset('js/mapGameState.js') }}"></script>
    <script type="text/javascript" src="{{ asset('js/chunks.js') }}"></script>
    <script type="text/javascript" src="{{ asset('js/mapSideMenu.js') }}"></script>
    <script type="text/javascript" src="{{ asset('js/mapSettings.js') }}"></script>
    <script type="text/javascript" src="{{ asset('js/general.js') }}"></script>
    <script type="text/javascript" src="{{ asset('js/mapRenderer.js') }}"></script>
    <script>
        // Server data - executed before js/map.js
        let worldName = {{ world.data.mapFileName }};
        let worldId = {{ world.id }};
        let mapServerData = JSON.parse(`{{ mapData | raw }}`);
        {% if isPlayingInWorld %}
        let myLordId = {{ lord.id }};
        let myCityID = `{{ lord.city.node.data.name | raw }}`;
        {% endif %}

        let flashMessages = [];
        {% for flashMessage in app.session.flashbag.get('error') %}
            flashMessages.push('{{ flashMessage }}');
        {% endfor %}

        {# TODO Cache all titles translations by name #}

        // Focus Node, Kingdom or General
        {% if focusedNode is defined and focusedNode is not empty %}
            focusedNode = "{{ focusedNode | raw }}";
        {% endif %}
        {% if focusedKingdom is defined and focusedKingdom is not empty %}
            focusedKingdomLordDbID = "{{ focusedKingdom | raw }}";
        {% endif %}
        {% if focusedGeneral is defined and focusedGeneral is not empty %}
            focusedGeneralDbID = {{ focusedGeneral | raw }};
        {% endif %}
    </script>
{% endblock %}

{% set worldName = world.name %}

{% block content %}
    <div id="map_tip" class="normalTip" style="display: none">
        <div class="tiptop">
            <div class="tipbottom">
                <div class="tipbg">
                    <div>
                        <h1>[Tooltip Title]</h1>
                        <ul class="infos">
                            <li id="Capital" style="display: none">
                                <img src="{{ asset('img/icons/capitale.gif') }}">{{ 'map.node.city.part1' | trans }} {{ 'map.node.city.part2' | trans }} <a id="LordLink" href="/user/795">Chevalier XXX</a>
                            </li>
                            <li id="Wild" style="display: none">
                                {{ 'map.node.wild' | trans }}
                            </li>
                            <li id="BarbarianCity" style="display: none">
                                {{ 'map.node.barbarian' | trans }}
                            </li>
                            <li id="Territory" style="display: none">
                                {{ 'map.node.ownedBy' | trans }} <a id="LordLink" href="/user/795">Chevalier XXX</a>
                            </li>
                            {% for resource in ['lin','iron','horse'] %}
                            <li id="resource{{ resource | capitalize }}" style="display: block">
                                {{ ('map.node.resourceSpot.'~resource) | trans }}
                                <div class="sres">
                                    <img src="{{ asset('img/icons/small/res_' ~ resource ~ '.gif') }}" alt="{{ resource }} small">
                                    <span class="number">135</span>
                                </div>
                            </li>
                            {% endfor %}
                            <li id="greputation">
                                {{ 'map.general.reputation' | trans }} : <strong>1</strong> <img src="{{ asset('img/icons/l_rep.png') }}">
                            </li>
                            <li id="gowner">
                                {{ 'map.general.owner' | trans }} <strong>Roi Hordemavue</strong>
                            </li>
                            <li id="gmoving">
                                {{ 'map.general.remainingTime' | trans }} : <div id="timerTooltip" class="timer">57m 40s</div>
                            </li>
                        </ul>
                        {% set unitsToDisplay = ['soldier', 'pikeman', 'archer', 'horseman', 'knight', 'mountedArcher', 'paladin', 'catapult', 'ballista'] %}
                        <h3 id="army1">{{ 'map.sideMenu.units.capital' | trans }}</h3>
                        <ul class="ismall" id="armyUnits1">
                            {% for unit in unitsToDisplay %}
                                <li>
                                    <div class="item">
                                        <img src="{{ asset('img/icons/small/u_' ~ unit ~ '.gif') }}" alt=""><span class="number">??</span>
                                    </div>
                                </li>
                            {% endfor %}
                        </ul>
                        <h3 id="army2">{{ 'map.sideMenu.units.territory' | trans }}</h3>
                        <ul class="ismall" id="armyUnits2">
                            {% for unit in unitsToDisplay %}
                                <li>
                                    <div class="item">
                                        <img src="{{ asset('img/icons/small/u_' ~ unit ~ '.gif') }}" alt=""><span class="number">??</span>
                                    </div>
                                </li>
                            {% endfor %}
                        </ul>
                        <div class="clear"></div>
                        <div class="reload" style="display: none"></div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div id="map_kingdom_tip" class="normalTip" style="display: none">
        [Kingdom Name]
    </div>
    <div class="map_frame">
        <h1>{{ 'map.mainHeader' | trans({'%name%':worldName})}}</h1>

        <canvas id="map_view"></canvas>
        <div class ="map_actions">
            <ul>
                <li id="zoom_in">
                    <img src="{{ asset('img/icons/map_zoom_in.gif') }}"  title="{{'map.leftButtons.zoomIn' | trans }}" alt="Zoom in button" />
                </li>
                <li id="zoom_out">
                    <img src="{{ asset('img/icons/map_zoom_out.gif') }}" title="{{'map.leftButtons.zoomOut' | trans }}" alt="Zoom out button" />
                </li>
                {% if isPlayingInWorld %}
                <li id="go_to_capital">
                    <img src="{{ asset('img/menu/capital.gif') }}" title="{{'map.leftButtons.goToCapital' | trans }}" alt="Go to capital" />
                </li>
                <li id="refresh_map">
                    <img src="{{ asset('img/icons/map_refresh.gif') }}" title="{{'map.leftButtons.refresh' | trans }}" alt="Refresh map" />
                </li>
                {% endif %}
                <li id="toggle_strat_mode">
                    <img src="{{ asset('img/menu/map.gif') }}" title="{{'map.leftButtons.strategy' | trans }}" alt="Strategy button" />
                </li>
                <li id="map_settings_icon">
                    <img src="{{ asset('img/icons/map_settings.gif') }}" title="{{'map.leftButtons.settings' | trans }}" alt="Display settings" />
                </li>
            </ul>
        </div>
        <div class ="map_feedback" style="display: none">
            <ul>
                <li id="choose_destination" style="display: none">
                    {{ 'map.general.chooseDestination' | trans }}
                </li>
            </ul>
        </div>
        {{ include('Map/Components/MapSideBar.html.twig') }}
        <div id="map_settings" class="map_settings" style="display: none">
            <div class="box3">
                <div class="box3bottom">
                    
                    <div class="box3bg">
                        <h3 class="h3d">
                            {{'map.settings.title' | trans }}
                            <a href="javascript:void(0)" class="closebtn" onclick="closeSettings()">
                                <img style="position: relative; top: 1px" src="{{ asset('img/icons/small/close.png') }}" alt="close">
                            </a>
                        </h3>
                        <form>
                            <ul>
                                {% if isPlayingInWorld %}
                                <li>
                                    <input type="checkbox" id="viewKingdom" name="viewKingdom" checked>
                                    <label for="viewKingdom">{{'map.settings.viewKingdom' | trans }}</label>
                                </li>
                                {% endif %}
                                <li>
                                    <input type="checkbox" id="animate" name="animate" checked>
                                    <label for="animate">{{'map.settings.animate' | trans }}</label>
                                </li>
                                <li>
                                    <label for="fpsLimit">{{'map.settings.fpsLimit' | trans }}</label>
                                    <input type="number" id="fpsLimit" name="fps_limit" maxlength="3" size="3" min="10" max="300" step="10" value="60"/>
                                </li>
                                {% if isPlayingInWorld %}
                                <li>
                                    <h4>{{'map.settings.generalsColor' | trans }}</h4>
                                </li>
                                <li class="hueLine">
                                    <label>{{'map.settings.myGeneralsHue' | trans }}</label>
                                    <input type="range" class="generalHueRange" name="myGeneralsHue", id="myGeneralsHue", min="0", max="360", step="1", value="240" />
                                    <output class="generalsHueOutput" id="myGeneralsHueOutput"></output>
                                </li>
                                <li class="hueLine">
                                    <label>{{'map.settings.vassalsGeneralsHue' | trans }}</label>
                                    <input type="range" class="generalHueRange" name="vassalsGeneralsHue", id="vassalsGeneralsHue", min="0", max="360", step="1", value="120" />
                                    <output class="generalsHueOutput" id="vassalsGeneralsHueOutput"></output>
                                </li>
                                <li class="hueLine">
                                    <label>{{'map.settings.lordGeneralsHue' | trans }}</label>
                                    <input type="range" class="generalHueRange" name="lordGeneralsHue", id="lordGeneralsHue", min="0", max="360", step="1", value="45" />
                                    <output class="generalsHueOutput" id="lordGeneralsHueOutput"></output>
                                </li>
                                <li class="hueLine">
                                    <label>{{'map.settings.otherGeneralsHue' | trans }}</label>
                                    <input type="range" class="generalHueRange" name="otherGeneralsHue", id="otherGeneralsHue", min="0", max="360", step="1", value="0" />
                                    <output class="generalsHueOutput" id="otherGeneralsHueOutput"></output>
                                </li>
                                {% endif %}
                                <li class="buttonsLine">
                                    <input type="button" class="button" onclick="applySettings()" value="{{'map.settings.apply' | trans }}" />
                                    <input type="button" class="button" onclick="resetSettings()" value="{{'map.settings.reset' | trans }}" />
                                </li>
                            </ul>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>

    {# General Shortcuts #}
    {% if isPlayingInWorld and lord.generals|length > 0 %}
        <div id="generals">
            <ul>
                {% for key, general in lord.generals %}
                    <li onclick="onClickMyGeneral({{ general.id }})">{{ general.name }}</li>
                {% endfor %}
            </ul>
        </div>
    {% endif %}

    {% include 'Components/LogsList.html.twig' with
        {
            'title': 'map.logsHeader' | trans({'%name%':worldName}),
            'logs': logs
        }
    %}

    {#
    <div class="log">
        <h3>{{ 'map.logsHeader' | trans({'%name%':worldName})}}</h3>
        <ul>
            <li><span class="datelog">Le 31 oct. à 20:53:19</span> - 
                <img src="{{ asset('/img/icons/l_up.png') }}">
                Suite à ses nombreuses conquêtes, <a href="http://kingdom.muxxu.com/user/1301742">flavce</a> a été proclamé <b>Baron</b>
            </li>
            <li><span class="datelog">Le 31 oct. à 20:36:41</span> - 
                <img src="{{ asset('img/icons/l_new.png') }}">
                Un jeune chevalier du nom de <a href="http://kingdom.muxxu.com/user/76802">sebodmer</a> a pris le contrôle de <a href="http://kingdom.muxxu.com/map?c=117614">Champeix</a>.
            </li>
            <li><span class="datelog">Le 31 oct. à 19:55:06</span> - 
                <img src="{{ asset('/img/icons/l_destroy.png') }}">
                Le Royaume du <a href="http://kingdom.muxxu.com/user/3331824">Chevalier Tabloid</a> s'est effondré : <a href="http://kingdom.muxxu.com/map/?c=117700">Confinement du Rousk</a> est désormais une ville Barbare.
            </li>
            <li><span class="datelog">Le 31 oct. à 19:50:07</span> - 
                <img src="{{ asset('/img/icons/small/res_horse.gif') }}">
                On a découvert une <b>Prairie</b> du côté de <a href="http://kingdom.muxxu.com/map?c=117506">Guineuve</a> !
            </li>
            <li><span class="datelog">Le 31 oct. à 19:50:06</span> - 
                <img src="{{ asset('/img/icons/l_conquest.png') }}">
                Le général <b>Sauce barbecue</b> sous les ordres du <a href="http://kingdom.muxxu.com/user/330542">Prince Banana</a> a conquis <a href="http://kingdom.muxxu.com/map?c=117738">Osailyac</a>.
            </li>
            <li><span class="datelog">Le 31 oct. à 19:45:06</span> - 
                <img src="{{ asset('/img/icons/l_conquest.png') }}">
                Le général <b>ASUS</b> sous les ordres du <a href="http://kingdom.muxxu.com/user/51644">Prince Ailleloviou</a> a conquis <a href="http://kingdom.muxxu.com/map?c=117379">Abystopia</a>.
            </li>
            <li><span class="datelog">Le 31 oct. à 19:10:06</span> - 
                <img src="{{ asset('/img/icons/l_destroy.png') }}">
                Le Royaume du <a href="http://kingdom.muxxu.com/user/4968850">Chevalier Zoxem</a> s'est effondré : <a href="http://kingdom.muxxu.com/map/?c=117690">Haarg McLeod</a> est désormais une ville Barbare.
            </li>
            <li><span class="datelog">Le 31 oct. à 18:35:39</span> - 
                <img src="{{ asset('/img/icons/l_new.png') }}">
                Un jeune chevalier du nom de <a href="http://kingdom.muxxu.com/user/4968850">Zoxem</a> a pris le contrôle de <a href="http://kingdom.muxxu.com/map?c=117690">Haarg McLeod</a>.
            </li>
            <li><span class="datelog">Le 31 oct. à 18:15:06</span> - 
                <img src="{{ asset('/img/icons/l_conquest.png') }}">
                Le général <b>schtroumpf</b> sous les ordres du <a href="http://kingdom.muxxu.com/user/2779400">Baron Lunairement</a> a conquis <a href="http://kingdom.muxxu.com/map?c=117470">Auxiryac</a>.
            </li>
            <li><span class="datelog">Le 31 oct. à 17:50:17</span> - 
                <img src="{{ asset('/img/icons/l_up.png') }}">
                Suite à ses nombreuses conquêtes, <a href="http://kingdom.muxxu.com/user/106873">Abbys</a> a été proclamé <b>Baron</b>
            </li>
            <li><span class="datelog">Le 31 oct. à 17:50:17</span> - 
                <img src="{{ asset('/img/icons/l_conquest.png') }}">
                Le général <b>Tonkin</b> sous les ordres du <a href="http://kingdom.muxxu.com/user/106873">Baron Abbys</a> a capturé
                <a href="http://kingdom.muxxu.com/map?c=117422">prisciland</a> sans aucune résistance
            </li>
            <li><span class="datelog">Le 31 oct. à 17:00:05</span> - 
                <img src="{{ asset('/img/icons/l_conquest.png') }}">
                Le général <b>Rigel</b> sous les ordres du <a href="http://kingdom.muxxu.com/user/4606023">Prince Huiry</a> a conquis <a href="http://kingdom.muxxu.com/map?c=117554">Luvaux</a>.
            </li>
        </ul>
    </div>
    #}
{% endblock %}